/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code MMU_PA} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MMU_PA extends RegisterMapping<MMU_PA.Entry, PA> {
  private static MMU_PA instance = null;

  public static MMU_PA get() {
    if (null == instance) {
      instance = new MMU_PA();
    }
    return instance;
  }

  public static final class Entry implements Data {
    public final BitVector value;

    public Entry() {
      this.value = BitVector.newEmpty(32);
    }

    public Entry(final BitVector value) {
      this();
      asBitVector().assign(value);
    }

    public void assign(final Entry other) {
      this.value.assign(other.value);
    }

    @Override
    public BitVector asBitVector() {
      return BitVector.newMapping(
          value
          );
    }

    @Override
    public String toString() {
      return String.format(
          "Entry [value=0x%s]",
          value.toHexString()
          );
    }
  }
  private static final Indexer<PA> INDEXER = new Indexer<PA>() {
    @Override
    public BitVector getIndex(final PA pa) {
      return BitVector.valueOf(0x0, 32);
    }
  };

  private static final Matcher<MMU_PA.Entry, PA> MATCHER = new Matcher<MMU_PA.Entry, PA>() {
    @Override
    public boolean areMatching(final MMU_PA.Entry data, final PA pa) {
      return true;
    }
  };

  private MMU_PA() {
    super(
      "MMU_PA",
      new BigInteger("1", 10),
      1,
      PolicyId.NONE,
      INDEXER,
      MATCHER
      );
  }

  @Override
  protected PA newAddress() {
    return new PA();
  }

  @Override
  protected Entry newData(final BitVector value) {
    return new Entry(value);
  }

  @Override
  protected int getDataBitSize() {
    return 32;
  }
}
