/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc;

import ru.ispras.microtesk.model.ModelBuilder;
import ru.ispras.microtesk.model.powerpc.metadata.MetaModelFactory;
import ru.ispras.microtesk.model.powerpc.decoder.Decoder;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.powerpc.op.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model extends ModelBuilder {
  public Model() {
    super(
        "powerpc",
        "",
        MetaModelFactory.newMetaModel(),
        Decoder.get(),
        PE.newFactory(),
        TempVars.newFactory()
        );

    addMode(R.INFO);
    addMode(FR.INFO);
    addMode(LI_IMM.INFO);
    addMode(LI_LABEL_ABS.INFO);
    addMode(LI_LABEL_REL.INFO);

    addOperation(nop.INFO);
    addOperation(sl_general_image.INFO);
    addOperation(slx_general_image.INFO);
    addOperation(powerpc_store.INFO);
    addOperation(store_general.INFO);
    addOperation(storex_general.INFO);
    addOperation(powerpc_load.INFO);
    addOperation(load_general.INFO);
    addOperation(loadx_general.INFO);
    addOperation(lhalhx_general.INFO);
    addOperation(lha_general.INFO);
    addOperation(lhax_general.INFO);
    addOperation(stw.INFO);
    addOperation(stwu.INFO);
    addOperation(stwx.INFO);
    addOperation(stwux.INFO);
    addOperation(stb.INFO);
    addOperation(stbu.INFO);
    addOperation(stbx.INFO);
    addOperation(stbux.INFO);
    addOperation(sth.INFO);
    addOperation(sthu.INFO);
    addOperation(sthx.INFO);
    addOperation(sthux.INFO);
    addOperation(lwz.INFO);
    addOperation(lwzu.INFO);
    addOperation(lwzx.INFO);
    addOperation(lwzux.INFO);
    addOperation(lbz.INFO);
    addOperation(lbzu.INFO);
    addOperation(lbzx.INFO);
    addOperation(lbzux.INFO);
    addOperation(lhz.INFO);
    addOperation(lhzu.INFO);
    addOperation(lhzx.INFO);
    addOperation(lhzux.INFO);
    addOperation(lha.INFO);
    addOperation(lhau.INFO);
    addOperation(lhax.INFO);
    addOperation(lhaux.INFO);
    addOperation(branch_general.INFO);
    addOperation(b.INFO);
    addOperation(ba.INFO);
    addOperation(bl.INFO);
    addOperation(bla.INFO);
    addOperation(bc_general.INFO);
    addOperation(bc.INFO);
    addOperation(bca.INFO);
    addOperation(bcl.INFO);
    addOperation(bcla.INFO);
    addOperation(bt.INFO);
    addOperation(bta.INFO);
    addOperation(btl.INFO);
    addOperation(btla.INFO);
    addOperation(bf.INFO);
    addOperation(bfa.INFO);
    addOperation(bfl.INFO);
    addOperation(bfla.INFO);
    addOperation(bclr_general.INFO);
    addOperation(bclr.INFO);
    addOperation(bclrl.INFO);
    addOperation(blr.INFO);
    addOperation(blrl.INFO);
    addOperation(bcctr_general.INFO);
    addOperation(bcctr.INFO);
    addOperation(bcctrl.INFO);
    addOperation(add_general.INFO);
    addOperation(add.INFO);
    addOperation(add_d.INFO);
    addOperation(addo.INFO);
    addOperation(addo_d.INFO);
    addOperation(addi.INFO);
    addOperation(subi.INFO);
    addOperation(li.INFO);
    addOperation(addc_general.INFO);
    addOperation(addc.INFO);
    addOperation(addc_d.INFO);
    addOperation(addco.INFO);
    addOperation(addco_d.INFO);
    addOperation(addic_general.INFO);
    addOperation(addic.INFO);
    addOperation(addic_d.INFO);
    addOperation(subic.INFO);
    addOperation(subic_d.INFO);
    addOperation(addis.INFO);
    addOperation(subis.INFO);
    addOperation(lis.INFO);
    addOperation(adde_general.INFO);
    addOperation(adde.INFO);
    addOperation(adde_d.INFO);
    addOperation(addeo.INFO);
    addOperation(addeo_d.INFO);
    addOperation(addme_general.INFO);
    addOperation(addme.INFO);
    addOperation(addme_d.INFO);
    addOperation(addmeo.INFO);
    addOperation(addmeo_d.INFO);
    addOperation(addze_general.INFO);
    addOperation(addze.INFO);
    addOperation(addze_d.INFO);
    addOperation(addzeo.INFO);
    addOperation(addzeo_d.INFO);
    addOperation(ori.INFO);
    addOperation(oris.INFO);
    addOperation(xori.INFO);
    addOperation(xoris.INFO);
    addOperation(subf_general.INFO);
    addOperation(subf.INFO);
    addOperation(subf_d.INFO);
    addOperation(subfo.INFO);
    addOperation(subfo_d.INFO);
    addOperation(sub.INFO);
    addOperation(sub_d.INFO);
    addOperation(subo.INFO);
    addOperation(subo_d.INFO);
    addOperation(subfc_general.INFO);
    addOperation(subfc.INFO);
    addOperation(subfc_d.INFO);
    addOperation(subfco.INFO);
    addOperation(subfco_d.INFO);
    addOperation(subc.INFO);
    addOperation(subc_d.INFO);
    addOperation(subco.INFO);
    addOperation(subco_d.INFO);
    addOperation(subfe_general.INFO);
    addOperation(subfe.INFO);
    addOperation(subfe_d.INFO);
    addOperation(subfeo.INFO);
    addOperation(subfeo_d.INFO);
    addOperation(subfic.INFO);
    addOperation(subfme_general.INFO);
    addOperation(subfme.INFO);
    addOperation(subfme_d.INFO);
    addOperation(subfmeo.INFO);
    addOperation(subfmeo_d.INFO);
    addOperation(subfze_general.INFO);
    addOperation(subfze.INFO);
    addOperation(subfze_d.INFO);
    addOperation(subfzeo.INFO);
    addOperation(subfzeo_d.INFO);
    addOperation(neg_general.INFO);
    addOperation(neg.INFO);
    addOperation(neg_d.INFO);
    addOperation(nego.INFO);
    addOperation(nego_d.INFO);
    addOperation(xor_general.INFO);
    addOperation(xor.INFO);
    addOperation(xor_d.INFO);
    addOperation(eqv_general.INFO);
    addOperation(eqv.INFO);
    addOperation(eqv_d.INFO);
    addOperation(extsb_general.INFO);
    addOperation(extsb.INFO);
    addOperation(extsb_d.INFO);
    addOperation(extsh_general.INFO);
    addOperation(extsh.INFO);
    addOperation(extsh_d.INFO);
    addOperation(rlwinm_general.INFO);
    addOperation(rlwinm.INFO);
    addOperation(rlwinm_d.INFO);
    addOperation(slwi.INFO);
    addOperation(slwi_d.INFO);
    addOperation(srwi.INFO);
    addOperation(srwi_d.INFO);
    addOperation(extlwi.INFO);
    addOperation(extlwi_d.INFO);
    addOperation(extrwi.INFO);
    addOperation(extrwi_d.INFO);
    addOperation(rotlwi.INFO);
    addOperation(rotlwi_d.INFO);
    addOperation(rotrwi.INFO);
    addOperation(rotrwi_d.INFO);
    addOperation(clrlwi.INFO);
    addOperation(clrlwi_d.INFO);
    addOperation(clrrwi.INFO);
    addOperation(clrrwi_d.INFO);
    addOperation(clrlslwi.INFO);
    addOperation(clrlslwi_d.INFO);
    addOperation(rlwnm_general.INFO);
    addOperation(rlwnm.INFO);
    addOperation(rlwnm_d.INFO);
    addOperation(rotlw.INFO);
    addOperation(rotlw_d.INFO);
    addOperation(rlwimi_general.INFO);
    addOperation(rlwimi.INFO);
    addOperation(rlwimi_d.INFO);
    addOperation(inslwi.INFO);
    addOperation(inslwi_d.INFO);
    addOperation(insrwi.INFO);
    addOperation(insrwi_d.INFO);
    addOperation(and_general.INFO);
    addOperation(and.INFO);
    addOperation(and_d.INFO);
    addOperation(andi_d.INFO);
    addOperation(andis_d.INFO);
    addOperation(andc_general.INFO);
    addOperation(andc.INFO);
    addOperation(andc_d.INFO);
    addOperation(nand_general.INFO);
    addOperation(nand.INFO);
    addOperation(nand_d.INFO);
    addOperation(or_general.INFO);
    addOperation(or.INFO);
    addOperation(or_d.INFO);
    addOperation(mr.INFO);
    addOperation(mr_d.INFO);
    addOperation(orc_general.INFO);
    addOperation(orc.INFO);
    addOperation(orc_d.INFO);
    addOperation(nor_general.INFO);
    addOperation(nor.INFO);
    addOperation(nor_d.INFO);
    addOperation(not.INFO);
    addOperation(not_d.INFO);
    addOperation(slw_general.INFO);
    addOperation(slw.INFO);
    addOperation(slw_d.INFO);
    addOperation(srw_general.INFO);
    addOperation(srw.INFO);
    addOperation(srw_d.INFO);
    addOperation(srawi_general.INFO);
    addOperation(srawi.INFO);
    addOperation(srawi_d.INFO);
    addOperation(sraw_general.INFO);
    addOperation(sraw.INFO);
    addOperation(sraw_d.INFO);
    addOperation(cmp.INFO);
    addOperation(cmpw.INFO);
    addOperation(cmpi.INFO);
    addOperation(cmpwi.INFO);
    addOperation(cmpl.INFO);
    addOperation(cmplw.INFO);
    addOperation(cmpli.INFO);
    addOperation(cmplwi.INFO);
    addOperation(mulhw_general.INFO);
    addOperation(mulhw.INFO);
    addOperation(mulhw_d.INFO);
    addOperation(mulhwu_general.INFO);
    addOperation(mulhwu.INFO);
    addOperation(mulhwu_d.INFO);
    addOperation(mullw_general.INFO);
    addOperation(mullw.INFO);
    addOperation(mullw_d.INFO);
    addOperation(mullwo.INFO);
    addOperation(mullwo_d.INFO);
    addOperation(mulli.INFO);
    addOperation(divw_general.INFO);
    addOperation(divw.INFO);
    addOperation(divw_d.INFO);
    addOperation(divwo.INFO);
    addOperation(divwo_d.INFO);
    addOperation(divwu_general.INFO);
    addOperation(divwu.INFO);
    addOperation(divwu_d.INFO);
    addOperation(divwuo.INFO);
    addOperation(divwuo_d.INFO);
    addOperation(instruction.INFO);
  }
}
