/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.addic_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.op.addic_general;

/**
 * The {@code DecoderAddic_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderAddic_d extends DecoderItem {
  private static DecoderAddic_d instance = null;

  public static DecoderAddic_d get() {
    if (null == instance) {
      instance = new DecoderAddic_d();
    }
    return instance;
  }

  private DecoderAddic_d() {
    super(
        32,
        true,
        "00110100000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R ra = null;
    Immediate simm = null;

    final addic_general addic_general_instance;
    addic_general_instance = (addic_general) readNextPrimitive(image, DecoderAddic_general.get());
    if (null == addic_general_instance) {
      return null;
    }
    rd = addic_general_instance.rd;
    ra = addic_general_instance.ra;
    simm = addic_general_instance.simm;

    return newResult(new addic_d(rd, ra, simm));
  }
}
