/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.andc_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.andc_general;

/**
 * The {@code DecoderAndc_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderAndc_d extends DecoderItem {
  private static DecoderAndc_d instance = null;

  public static DecoderAndc_d get() {
    if (null == instance) {
      instance = new DecoderAndc_d();
    }
    return instance;
  }

  private DecoderAndc_d() {
    super(
        32,
        true,
        "01111100000000000000000001111001",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R ra = null;
    R rs = null;
    R rb = null;

    final andc_general andc_general_instance;
    andc_general_instance = (andc_general) readNextPrimitive(image, DecoderAndc_general.get());
    if (null == andc_general_instance) {
      return null;
    }
    ra = andc_general_instance.ra;
    rs = andc_general_instance.rs;
    rb = andc_general_instance.rb;

    return newResult(new andc_d(ra, rs, rb));
  }
}
