/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.bc;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.op.bc_general;

/**
 * The {@code DecoderBc} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBc extends DecoderItem {
  private static DecoderBc instance = null;

  public static DecoderBc get() {
    if (null == instance) {
      instance = new DecoderBc();
    }
    return instance;
  }

  private DecoderBc() {
    super(
        32,
        true,
        "01000000000000000000000000000000",
        "11111100000000000000000000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate BO_op = null;
    Immediate BI_op = null;
    Immediate BD = null;

    final bc_general bc_general_instance;
    bc_general_instance = (bc_general) readNextPrimitive(image, DecoderBc_general.get());
    if (null == bc_general_instance) {
      return null;
    }
    BO_op = bc_general_instance.BO_op;
    BI_op = bc_general_instance.BI_op;
    BD = bc_general_instance.BD;

    return newResult(new bc(BO_op, BI_op, BD));
  }
}
