/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.bc_general;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderBc_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBc_general extends DecoderItem {
  private static DecoderBc_general instance = null;

  public static DecoderBc_general get() {
    if (null == instance) {
      instance = new DecoderBc_general();
    }
    return instance;
  }

  private DecoderBc_general() {
    super(
        32,
        true,
        "01000000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate BO_op = null;
    Immediate BI_op = null;
    Immediate BD = null;
    Immediate AA_op = null;
    Immediate LK_op = null;

    if (!matchNextOpc(image, BitVector.valueOf("010000", 2, 6))) {
      return null;
    }
    BO_op = readNextImmediate(image, SHIFT);
    BI_op = readNextImmediate(image, SHIFT);
    BD = readNextImmediate(image, Type.INT(14));
    AA_op = readNextImmediate(image, BIT);
    LK_op = readNextImmediate(image, BIT);

    return newResult(new bc_general(BO_op, BI_op, BD, AA_op, LK_op));
  }
}
