/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.bclr_general;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderBclr_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBclr_general extends DecoderItem {
  private static DecoderBclr_general instance = null;

  public static DecoderBclr_general get() {
    if (null == instance) {
      instance = new DecoderBclr_general();
    }
    return instance;
  }

  private DecoderBclr_general() {
    super(
        32,
        true,
        "01001100000000000000000000100000",
        "11111100000000001110011111111110"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate BO_op = null;
    Immediate BI_op = null;
    Immediate BH_op = null;
    Immediate LK_op = null;

    if (!matchNextOpc(image, BitVector.valueOf("010011", 2, 6))) {
      return null;
    }
    BO_op = readNextImmediate(image, SHIFT);
    BI_op = readNextImmediate(image, SHIFT);
    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    BH_op = readNextImmediate(image, Type.CARD(2));
    if (!matchNextOpc(image, BitVector.valueOf("0000010000", 2, 10))) {
      return null;
    }
    LK_op = readNextImmediate(image, BIT);

    return newResult(new bclr_general(BO_op, BI_op, BH_op, LK_op));
  }
}
