/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.bl;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.powerpc.op.branch_general;

/**
 * The {@code DecoderBl} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBl extends DecoderItem {
  private static DecoderBl instance = null;

  public static DecoderBl get() {
    if (null == instance) {
      instance = new DecoderBl();
    }
    return instance;
  }

  private DecoderBl() {
    super(
        32,
        true,
        "01001000000000000000000000000001",
        "11111100000000000000000000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    IsaPrimitive LI = null;

    final branch_general branch_general_instance;
    branch_general_instance = (branch_general) readNextPrimitive(image, DecoderBranch_general.get());
    if (null == branch_general_instance) {
      return null;
    }
    LI = branch_general_instance.LI_op;

    return newResult(new bl(LI));
  }
}
