/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.branch_general;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderBranch_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBranch_general extends DecoderItem {
  private static DecoderBranch_general instance = null;

  public static DecoderBranch_general get() {
    if (null == instance) {
      instance = new DecoderBranch_general();
    }
    return instance;
  }

  private DecoderBranch_general() {
    super(
        32,
        true,
        "01001000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate LK_op = null;
    Immediate AA_op = null;
    IsaPrimitive LI_op = null;

    if (!matchNextOpc(image, BitVector.valueOf("010010", 2, 6))) {
      return null;
    }
    LI_op = (IsaPrimitive) readNextPrimitive(image, DecoderLI_GENERAL.get());
    if (null == LI_op) {
      return null;
    }
    AA_op = readNextImmediate(image, BIT);
    LK_op = readNextImmediate(image, BIT);

    return newResult(new branch_general(LK_op, AA_op, LI_op));
  }
}
