/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.eqv;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.eqv_general;

/**
 * The {@code DecoderEqv} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderEqv extends DecoderItem {
  private static DecoderEqv instance = null;

  public static DecoderEqv get() {
    if (null == instance) {
      instance = new DecoderEqv();
    }
    return instance;
  }

  private DecoderEqv() {
    super(
        32,
        true,
        "01111100000000000000001000111000",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R ra = null;
    R rs = null;
    R rb = null;

    final eqv_general eqv_general_instance;
    eqv_general_instance = (eqv_general) readNextPrimitive(image, DecoderEqv_general.get());
    if (null == eqv_general_instance) {
      return null;
    }
    ra = eqv_general_instance.ra;
    rs = eqv_general_instance.rs;
    rb = eqv_general_instance.rb;

    return newResult(new eqv(ra, rs, rb));
  }
}
