/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.lhz;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.op.sl_general_image;

/**
 * The {@code DecoderLhz} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLhz extends DecoderItem {
  private static DecoderLhz instance = null;

  public static DecoderLhz get() {
    if (null == instance) {
      instance = new DecoderLhz();
    }
    return instance;
  }

  private DecoderLhz() {
    super(
        32,
        true,
        "10100000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    Immediate D = null;
    R ra = null;

    final sl_general_image sl_general_image_instance;
    sl_general_image_instance = (sl_general_image) readNextPrimitive(image, DecoderSl_general_image.get());
    if (null == sl_general_image_instance) {
      return null;
    }
    rd = sl_general_image_instance.rsd;
    D = sl_general_image_instance.D;
    ra = sl_general_image_instance.ra;

    return newResult(new lhz(rd, D, ra));
  }
}
