/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.orc_general;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.powerpc.mode.R;

/**
 * The {@code DecoderOrc_general} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderOrc_general extends DecoderItem {
  private static DecoderOrc_general instance = null;

  public static DecoderOrc_general get() {
    if (null == instance) {
      instance = new DecoderOrc_general();
    }
    return instance;
  }

  private DecoderOrc_general() {
    super(
        32,
        true,
        "01111100000000000000001100111000",
        "11111100000000000000011111111110"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate Rc_op = null;
    R ra = null;
    R rs = null;
    R rb = null;

    if (!matchNextOpc(image, BitVector.valueOf("011111", 2, 6))) {
      return null;
    }
    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }
    ra = (R) readNextPrimitive(image, DecoderR.get());
    if (null == ra) {
      return null;
    }
    rb = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rb) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0110011100", 2, 10))) {
      return null;
    }
    Rc_op = readNextImmediate(image, BIT);

    return newResult(new orc_general(Rc_op, ra, rs, rb));
  }
}
