/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.subfco_d;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.subfc_general;

/**
 * The {@code DecoderSubfco_d} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSubfco_d extends DecoderItem {
  private static DecoderSubfco_d instance = null;

  public static DecoderSubfco_d get() {
    if (null == instance) {
      instance = new DecoderSubfco_d();
    }
    return instance;
  }

  private DecoderSubfco_d() {
    super(
        32,
        true,
        "01111100000000000000010000010001",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R ra = null;
    R rb = null;

    final subfc_general subfc_general_instance;
    subfc_general_instance = (subfc_general) readNextPrimitive(image, DecoderSubfc_general.get());
    if (null == subfc_general_instance) {
      return null;
    }
    rd = subfc_general_instance.rd;
    ra = subfc_general_instance.ra;
    rb = subfc_general_instance.rb;

    return newResult(new subfco_d(rd, ra, rb));
  }
}
