/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.subfe;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.subfe_general;

/**
 * The {@code DecoderSubfe} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSubfe extends DecoderItem {
  private static DecoderSubfe instance = null;

  public static DecoderSubfe get() {
    if (null == instance) {
      instance = new DecoderSubfe();
    }
    return instance;
  }

  private DecoderSubfe() {
    super(
        32,
        true,
        "01111100000000000000000100010000",
        "11111100000000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R ra = null;
    R rb = null;

    final subfe_general subfe_general_instance;
    subfe_general_instance = (subfe_general) readNextPrimitive(image, DecoderSubfe_general.get());
    if (null == subfe_general_instance) {
      return null;
    }
    rd = subfe_general_instance.rd;
    ra = subfe_general_instance.ra;
    rb = subfe_general_instance.rb;

    return newResult(new subfe(rd, ra, rb));
  }
}
