/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.decoder;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.op.subfze;
import ru.ispras.microtesk.model.powerpc.mode.R;
import ru.ispras.microtesk.model.powerpc.op.subfze_general;

/**
 * The {@code DecoderSubfze} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSubfze extends DecoderItem {
  private static DecoderSubfze instance = null;

  public static DecoderSubfze get() {
    if (null == instance) {
      instance = new DecoderSubfze();
    }
    return instance;
  }

  private DecoderSubfze() {
    super(
        32,
        true,
        "01111100000000000000000110010000",
        "11111100000000001111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R ra = null;

    final subfze_general subfze_general_instance;
    subfze_general_instance = (subfze_general) readNextPrimitive(image, DecoderSubfze_general.get());
    if (null == subfze_general_instance) {
      return null;
    }
    rd = subfze_general_instance.rd;
    ra = subfze_general_instance.ra;

    return newResult(new subfze(rd, ra));
  }
}
