/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.metadata;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

import java.math.BigInteger;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.metadata.MetaModel;
import ru.ispras.microtesk.model.metadata.MetaModelBuilder;

/**
 * The {@code MetaModelFactory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModelFactory {
  private MetaModelFactory() {}

  public static MetaModel newMetaModel() {
    final MetaModelBuilder builder = new MetaModelBuilder();

    builder.addRegister("CIA", DWORD, 1);
    builder.addRegister("GPR", WORD, 32);
    builder.addRegister("FPR", DWORD, 32);
    builder.addRegister("SPR", DWORD, 1024);
    builder.addRegister("XER", DWORD, 1);
    builder.addRegister("CSRR0", DWORD, 1);
    builder.addRegister("CSRR1", DWORD, 1);
    builder.addRegister("LR", DWORD, 1);
    builder.addRegister("CTR", DWORD, 1);
    builder.addRegister("DAC1", DWORD, 1);
    builder.addRegister("DAC2", DWORD, 1);
    builder.addRegister("DBCR0", DWORD, 1);
    builder.addRegister("DBCR1", DWORD, 1);
    builder.addRegister("DBCR2", DWORD, 1);
    builder.addRegister("DBSR", DWORD, 1);
    builder.addRegister("XER_SO", BIT, 1);
    builder.addRegister("XER_OV", BIT, 1);
    builder.addRegister("XER_CA", BIT, 1);
    builder.addRegister("CR", WORD, 1);
    builder.addRegister("CR0", Type.CARD(4), 1);
    builder.addRegister("CR1", Type.CARD(4), 1);
    builder.addRegister("CR2", Type.CARD(4), 1);
    builder.addRegister("CR3", Type.CARD(4), 1);
    builder.addRegister("CR4", Type.CARD(4), 1);
    builder.addRegister("CR5", Type.CARD(4), 1);
    builder.addRegister("CR6", Type.CARD(4), 1);
    builder.addRegister("CR7", Type.CARD(4), 1);
    builder.addRegister("CR0_LT", BIT, 1);
    builder.addRegister("CR0_GT", BIT, 1);
    builder.addRegister("CR0_EQ", BIT, 1);
    builder.addRegister("CR0_SO", BIT, 1);

    builder.addMemory("BRANCH", BIT, 0x1);
    builder.addMemory("NEXTPC", DWORD, 0x1);
    builder.addMemory("MEM", DWORD, 0x20000000);

    builder.addMode(R.get());
    builder.addMode(FR.get());
    builder.addMode(LI_IMM.get());
    builder.addMode(LI_LABEL_ABS.get());
    builder.addMode(LI_LABEL_REL.get());
    builder.addMode(LI_ABS.get());
    builder.addMode(LI_REL.get());
    builder.addMode(LI_GENERAL.get());

    builder.addOperation(nop.get());
    builder.addOperation(PowerPCNopOp.get());
    builder.addOperation(stw.get());
    builder.addOperation(stwu.get());
    builder.addOperation(stwx.get());
    builder.addOperation(stwux.get());
    builder.addOperation(stb.get());
    builder.addOperation(stbu.get());
    builder.addOperation(stbx.get());
    builder.addOperation(stbux.get());
    builder.addOperation(sth.get());
    builder.addOperation(sthu.get());
    builder.addOperation(sthx.get());
    builder.addOperation(sthux.get());
    builder.addOperation(lwz.get());
    builder.addOperation(lwzu.get());
    builder.addOperation(lwzx.get());
    builder.addOperation(lwzux.get());
    builder.addOperation(lbz.get());
    builder.addOperation(lbzu.get());
    builder.addOperation(lbzx.get());
    builder.addOperation(lbzux.get());
    builder.addOperation(lhz.get());
    builder.addOperation(lhzu.get());
    builder.addOperation(lhzx.get());
    builder.addOperation(lhzux.get());
    builder.addOperation(lha.get());
    builder.addOperation(lhau.get());
    builder.addOperation(lhax.get());
    builder.addOperation(lhaux.get());
    builder.addOperation(PowerPCMmuOp.get());
    builder.addOperation(b.get());
    builder.addOperation(ba.get());
    builder.addOperation(bl.get());
    builder.addOperation(bla.get());
    builder.addOperation(bc.get());
    builder.addOperation(bca.get());
    builder.addOperation(bcl.get());
    builder.addOperation(bcla.get());
    builder.addOperation(bt.get());
    builder.addOperation(bta.get());
    builder.addOperation(btl.get());
    builder.addOperation(btla.get());
    builder.addOperation(bf.get());
    builder.addOperation(bfa.get());
    builder.addOperation(bfl.get());
    builder.addOperation(bfla.get());
    builder.addOperation(bclr.get());
    builder.addOperation(bclrl.get());
    builder.addOperation(blr.get());
    builder.addOperation(blrl.get());
    builder.addOperation(bcctr.get());
    builder.addOperation(bcctrl.get());
    builder.addOperation(PowerPCBpuBranch.get());
    builder.addOperation(PowerPCBpuOp.get());
    builder.addOperation(add.get());
    builder.addOperation(add_d.get());
    builder.addOperation(addo.get());
    builder.addOperation(addo_d.get());
    builder.addOperation(addi.get());
    builder.addOperation(subi.get());
    builder.addOperation(li.get());
    builder.addOperation(addc.get());
    builder.addOperation(addc_d.get());
    builder.addOperation(addco.get());
    builder.addOperation(addco_d.get());
    builder.addOperation(addic_general.get());
    builder.addOperation(addic.get());
    builder.addOperation(addic_d.get());
    builder.addOperation(subic.get());
    builder.addOperation(subic_d.get());
    builder.addOperation(addis.get());
    builder.addOperation(subis.get());
    builder.addOperation(lis.get());
    builder.addOperation(adde.get());
    builder.addOperation(adde_d.get());
    builder.addOperation(addeo.get());
    builder.addOperation(addeo_d.get());
    builder.addOperation(addme.get());
    builder.addOperation(addme_d.get());
    builder.addOperation(addmeo.get());
    builder.addOperation(addmeo_d.get());
    builder.addOperation(addze.get());
    builder.addOperation(addze_d.get());
    builder.addOperation(addzeo.get());
    builder.addOperation(addzeo_d.get());
    builder.addOperation(ori.get());
    builder.addOperation(oris.get());
    builder.addOperation(xori.get());
    builder.addOperation(xoris.get());
    builder.addOperation(subf.get());
    builder.addOperation(subf_d.get());
    builder.addOperation(subfo.get());
    builder.addOperation(subfo_d.get());
    builder.addOperation(sub.get());
    builder.addOperation(sub_d.get());
    builder.addOperation(subo.get());
    builder.addOperation(subo_d.get());
    builder.addOperation(subfc.get());
    builder.addOperation(subfc_d.get());
    builder.addOperation(subfco.get());
    builder.addOperation(subfco_d.get());
    builder.addOperation(subc.get());
    builder.addOperation(subc_d.get());
    builder.addOperation(subco.get());
    builder.addOperation(subco_d.get());
    builder.addOperation(subfe.get());
    builder.addOperation(subfe_d.get());
    builder.addOperation(subfeo.get());
    builder.addOperation(subfeo_d.get());
    builder.addOperation(subfic.get());
    builder.addOperation(subfme.get());
    builder.addOperation(subfme_d.get());
    builder.addOperation(subfmeo.get());
    builder.addOperation(subfmeo_d.get());
    builder.addOperation(subfze.get());
    builder.addOperation(subfze_d.get());
    builder.addOperation(subfzeo.get());
    builder.addOperation(subfzeo_d.get());
    builder.addOperation(neg.get());
    builder.addOperation(neg_d.get());
    builder.addOperation(nego.get());
    builder.addOperation(nego_d.get());
    builder.addOperation(xor.get());
    builder.addOperation(xor_d.get());
    builder.addOperation(eqv.get());
    builder.addOperation(eqv_d.get());
    builder.addOperation(extsb.get());
    builder.addOperation(extsb_d.get());
    builder.addOperation(extsh.get());
    builder.addOperation(extsh_d.get());
    builder.addOperation(rlwinm.get());
    builder.addOperation(rlwinm_d.get());
    builder.addOperation(slwi.get());
    builder.addOperation(slwi_d.get());
    builder.addOperation(srwi.get());
    builder.addOperation(srwi_d.get());
    builder.addOperation(extlwi.get());
    builder.addOperation(extlwi_d.get());
    builder.addOperation(extrwi.get());
    builder.addOperation(extrwi_d.get());
    builder.addOperation(rotlwi.get());
    builder.addOperation(rotlwi_d.get());
    builder.addOperation(rotrwi.get());
    builder.addOperation(rotrwi_d.get());
    builder.addOperation(clrlwi.get());
    builder.addOperation(clrlwi_d.get());
    builder.addOperation(clrrwi.get());
    builder.addOperation(clrrwi_d.get());
    builder.addOperation(clrlslwi.get());
    builder.addOperation(clrlslwi_d.get());
    builder.addOperation(rlwnm.get());
    builder.addOperation(rlwnm_d.get());
    builder.addOperation(rotlw.get());
    builder.addOperation(rotlw_d.get());
    builder.addOperation(rlwimi.get());
    builder.addOperation(rlwimi_d.get());
    builder.addOperation(inslwi.get());
    builder.addOperation(inslwi_d.get());
    builder.addOperation(insrwi.get());
    builder.addOperation(insrwi_d.get());
    builder.addOperation(and.get());
    builder.addOperation(and_d.get());
    builder.addOperation(andi_d.get());
    builder.addOperation(andis_d.get());
    builder.addOperation(andc.get());
    builder.addOperation(andc_d.get());
    builder.addOperation(nand.get());
    builder.addOperation(nand_d.get());
    builder.addOperation(or.get());
    builder.addOperation(or_d.get());
    builder.addOperation(mr.get());
    builder.addOperation(mr_d.get());
    builder.addOperation(orc.get());
    builder.addOperation(orc_d.get());
    builder.addOperation(nor.get());
    builder.addOperation(nor_d.get());
    builder.addOperation(not.get());
    builder.addOperation(not_d.get());
    builder.addOperation(slw.get());
    builder.addOperation(slw_d.get());
    builder.addOperation(srw.get());
    builder.addOperation(srw_d.get());
    builder.addOperation(srawi.get());
    builder.addOperation(srawi_d.get());
    builder.addOperation(sraw.get());
    builder.addOperation(sraw_d.get());
    builder.addOperation(cmp.get());
    builder.addOperation(cmpw.get());
    builder.addOperation(cmpi.get());
    builder.addOperation(cmpwi.get());
    builder.addOperation(cmpl.get());
    builder.addOperation(cmplw.get());
    builder.addOperation(cmpli.get());
    builder.addOperation(cmplwi.get());
    builder.addOperation(mulhw.get());
    builder.addOperation(mulhw_d.get());
    builder.addOperation(mulhwu.get());
    builder.addOperation(mulhwu_d.get());
    builder.addOperation(mullw.get());
    builder.addOperation(mullw_d.get());
    builder.addOperation(mullwo.get());
    builder.addOperation(mullwo_d.get());
    builder.addOperation(mulli.get());
    builder.addOperation(divw.get());
    builder.addOperation(divw_d.get());
    builder.addOperation(divwo.get());
    builder.addOperation(divwo_d.get());
    builder.addOperation(divwu.get());
    builder.addOperation(divwu_d.get());
    builder.addOperation(divwuo.get());
    builder.addOperation(divwuo_d.get());
    builder.addOperation(PowerPCArithmetic.get());
    builder.addOperation(PowerPCAluOp.get());
    builder.addOperation(Op.get());
    builder.addOperation(instruction.get());

    return builder.build();
  }
}
