/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class bc_general extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "bc_general",
          bc_general.class,
          null
          );
      addArgument("BO_op", SHIFT);
      addArgument("BI_op", SHIFT);
      addArgument("BD", Type.INT(14));
      addArgument("AA_op", BIT);
      addArgument("LK_op", BIT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO_op = (Immediate) getArgument("BO_op", args);
      final Immediate BI_op = (Immediate) getArgument("BI_op", args);
      final Immediate BD = (Immediate) getArgument("BD", args);
      final Immediate AA_op = (Immediate) getArgument("AA_op", args);
      final Immediate LK_op = (Immediate) getArgument("LK_op", args);

      return new bc_general(BO_op, BI_op, BD, AA_op, LK_op);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate BO_op;
  public final Immediate BI_op;
  public final Immediate BD;
  public final Immediate AA_op;
  public final Immediate LK_op;

  public bc_general(final Immediate BO_op, final Immediate BI_op, final Immediate BD, final Immediate AA_op, final Immediate LK_op) {
    this.BO_op = BO_op;
    this.BI_op = BI_op;
    this.BD = BD;
    this.AA_op = AA_op;
    this.LK_op = LK_op;

    addArgument("BO_op", BO_op);
    addArgument("BI_op", BI_op);
    addArgument("BD", BD);
    addArgument("AA_op", AA_op);
    addArgument("LK_op", LK_op);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x10));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%d %d %d", BO_op.access().load().bigIntegerValue(), BI_op.access().load().bigIntegerValue(), BD.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%5s%5s%14s%1s%1s", vars__.OPCD.access().load().toString(), BO_op.access().load().toString(), BI_op.access().load().toString(), BD.access().load().toString(), AA_op.access().load().toString(), LK_op.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
    if (BO_op.access().bitField(2, 2).load().equals(Data.valueOf(BIT, 0x0))) {
      pe__.CTR.access().store(pe__.CTR.access().load().subtract(Data.valueOf(DWORD, 0x1)));
    }
    if (pe__.CTR.access().bitField(63, 0).load().equals(Data.valueOf(DWORD, 0x0))) {
      vars__.temp_bit.access().store(BO_op.access().bitField(2, 2).load().or(BO_op.access().bitField(1, 1).load()));
    } else {
      vars__.temp_bit.access().store(BO_op.access().bitField(2, 2).load().or(BO_op.access().bitField(1, 1).load().not()));
    }
    if (pe__.CR.access().load().shiftLeft(Data.valueOf(SHIFT, 0x1f).subtract(BI_op.access().load())).shiftRight(Data.valueOf(WORD, 0x1f)).equals(Data.zeroExtend(WORD, BO_op.access().bitField(3, 3).load()))) {
      vars__.temp_bit0.access().store(Data.valueOf(BIT, 0x1));
    } else {
      vars__.temp_bit0.access().store(BO_op.access().bitField(4, 4).load());
    }
    if (!vars__.temp_bit.access().load().and(vars__.temp_bit0.access().load()).equals(Data.valueOf(BIT, 0x0))) {
      if (AA_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
        vars__.temp1.access().store(Data.valueOf(WORD, 0x0));
      } else {
        vars__.temp1.access().store(pe__.CIA.access().bitField(31, 0).load());
      }
      pe__.NEXTPC.access().bitField(31, 0).store(pe__.CIA.access().bitField(31, 0).load().add(Data.cast(WORD, Data.signExtend(WORD, BD.access().load()))).shiftLeft(Data.valueOf(Type.CARD(32), 0x2)));
    } else {
      pe__.NEXTPC.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)));
    }
    if (LK_op.access().load().equals(Data.valueOf(BIT, 0x1))) {
      pe__.LR.access().store(pe__.CIA.access().load().add(Data.valueOf(DWORD, 0x4)));
    }
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}