/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class bcctr extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "bcctr",
          bcctr.class,
          null
          );
      addArgument("BO_op", SHIFT);
      addArgument("BI", SHIFT);
      addArgument("BH", Type.CARD(2));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO_op = (Immediate) getArgument("BO_op", args);
      final Immediate BI = (Immediate) getArgument("BI", args);
      final Immediate BH = (Immediate) getArgument("BH", args);

      return new bcctr(BO_op, BI, BH);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "bcctr",
          instruction.class,
          null
          );
      addArgument("BO_op", SHIFT);
      addArgument("BI", SHIFT);
      addArgument("BH", Type.CARD(2));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate BO_op = (Immediate) getArgument("BO_op", args);
      final Immediate BI = (Immediate) getArgument("BI", args);
      final Immediate BH = (Immediate) getArgument("BH", args);

      return new instruction(
        new bcctr(
          BO_op,
          BI,
          BH
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate BO_op;
  public final Immediate BI;
  public final Immediate BH;

  public bcctr(final Immediate BO_op, final Immediate BI, final Immediate BH) {
    this.BO_op = BO_op;
    this.BI = BI;
    this.BH = BH;

    addArgument("BO_op", BO_op);
    addArgument("BI", BI);
    addArgument("BH", BH);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.LK.access().store(Data.valueOf(BIT, 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("bcctr %s", new bcctr_general(BO_op, BI, BH, new Immediate(vars__.LK.access())).text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s", new bcctr_general(BO_op, BI, BH, new Immediate(vars__.LK.access())).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new bcctr_general(BO_op, BI, BH, new Immediate(vars__.LK.access())).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}