/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class cmpi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "cmpi",
          cmpi.class,
          null
          );
      addArgument("crfD", CRFD);
      addArgument("L", BIT);
      addArgument("ra", R.INFO);
      addArgument("SIMM", SHORT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate crfD = (Immediate) getArgument("crfD", args);
      final Immediate L = (Immediate) getArgument("L", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate SIMM = (Immediate) getArgument("SIMM", args);

      return new cmpi(crfD, L, ra, SIMM);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "cmpi",
          instruction.class,
          null
          );
      addArgument("crfD", CRFD);
      addArgument("L", BIT);
      addArgument("ra", R.INFO);
      addArgument("SIMM", SHORT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate crfD = (Immediate) getArgument("crfD", args);
      final Immediate L = (Immediate) getArgument("L", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate SIMM = (Immediate) getArgument("SIMM", args);

      return new instruction(
        new cmpi(
          crfD,
          L,
          ra,
          SIMM
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate crfD;
  public final Immediate L;
  public final R ra;
  public final Immediate SIMM;

  public cmpi(final Immediate crfD, final Immediate L, final R ra, final Immediate SIMM) {
    this.crfD = crfD;
    this.L = L;
    this.ra = ra;
    this.SIMM = SIMM;

    addArgument("crfD", crfD);
    addArgument("L", L);
    addArgument("ra", ra);
    addArgument("SIMM", SIMM);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0xb));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("cmp %d, %d, %s, %d", crfD.access().load().bigIntegerValue(), L.access().load().bigIntegerValue(), ra.text(vars__), SIMM.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%3s%1s%1s%5s%16s", vars__.OPCD.access().load().toString(), crfD.access().load().toString(), L.access().load().toString(), "0", ra.image(vars__), SIMM.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    if (L.access().load().equals(Data.valueOf(BIT, 0x0))) {
      if ((Data.cast(INT, ra.access(pe__, vars__).load()).compareTo(Data.signExtend(INT, SIMM.access().load())) < 0)) {
        vars__.temp.access().store(Data.valueOf(WORD, 0x1));
      }
      if ((Data.cast(INT, ra.access(pe__, vars__).load()).compareTo(Data.signExtend(INT, SIMM.access().load())) > 0)) {
        vars__.temp.access().store(Data.valueOf(WORD, 0x2));
      }
      if (Data.cast(INT, ra.access(pe__, vars__).load()).equals(Data.signExtend(INT, SIMM.access().load()))) {
        vars__.temp.access().store(Data.valueOf(WORD, 0x4));
      }
      pe__.CR.access().bitField(Data.zeroExtend(Type.CARD(5), crfD.access().load()).multiply(Data.valueOf(Type.CARD(5), 0x4)).add(Data.valueOf(Type.CARD(5), 0x2)), Data.zeroExtend(Type.CARD(5), crfD.access().load()).multiply(Data.valueOf(Type.CARD(5), 0x4))).store(Data.coerce(Type.CARD(3), vars__.temp.access().load()));
      pe__.CR.access().bitField(Data.zeroExtend(Type.CARD(5), crfD.access().load()).multiply(Data.valueOf(Type.CARD(5), 0x4)).add(Data.valueOf(Type.CARD(5), 0x3)), Data.zeroExtend(Type.CARD(5), crfD.access().load()).multiply(Data.valueOf(Type.CARD(5), 0x4)).add(Data.valueOf(Type.CARD(5), 0x3))).store(pe__.XER_SO.access().load());
    }
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}