/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class cmplwi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "cmplwi",
          cmplwi.class,
          null
          );
      addArgument("crfD", CRFD);
      addArgument("ra", R.INFO);
      addArgument("UIMM", HWORD);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate crfD = (Immediate) getArgument("crfD", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate UIMM = (Immediate) getArgument("UIMM", args);

      return new cmplwi(crfD, ra, UIMM);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "cmplwi",
          instruction.class,
          null
          );
      addArgument("crfD", CRFD);
      addArgument("ra", R.INFO);
      addArgument("UIMM", HWORD);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate crfD = (Immediate) getArgument("crfD", args);
      final R ra = (R) getArgument("ra", args);
      final Immediate UIMM = (Immediate) getArgument("UIMM", args);

      return new instruction(
        new cmplwi(
          crfD,
          ra,
          UIMM
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate crfD;
  public final R ra;
  public final Immediate UIMM;

  public cmplwi(final Immediate crfD, final R ra, final Immediate UIMM) {
    this.crfD = crfD;
    this.ra = ra;
    this.UIMM = UIMM;

    addArgument("crfD", crfD);
    addArgument("ra", ra);
    addArgument("UIMM", UIMM);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("cmplwi %d, %s, %d", crfD.access().load().bigIntegerValue(), ra.text(vars__), UIMM.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s", new cmpli(crfD, new Immediate(Data.valueOf(BIT, 0x0)), ra, UIMM).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new cmpli(crfD, new Immediate(Data.valueOf(BIT, 0x0)), ra, UIMM).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}