/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class insrwi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "insrwi",
          insrwi.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("n", SHIFT);
      addArgument("k", SHIFT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate n = (Immediate) getArgument("n", args);
      final Immediate k = (Immediate) getArgument("k", args);

      return new insrwi(ra, rs, n, k);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "insrwi",
          instruction.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("n", SHIFT);
      addArgument("k", SHIFT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate n = (Immediate) getArgument("n", args);
      final Immediate k = (Immediate) getArgument("k", args);

      return new instruction(
        new insrwi(
          ra,
          rs,
          n,
          k
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R ra;
  public final R rs;
  public final Immediate n;
  public final Immediate k;

  public insrwi(final R ra, final R rs, final Immediate n, final Immediate k) {
    this.ra = ra;
    this.rs = rs;
    this.n = n;
    this.k = k;

    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("n", n);
    addArgument("k", k);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.Rc.access().store(Data.valueOf(BIT, 0x0));
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x2a));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("insrwi %s, %s, %d, %d", ra.text(vars__), rs.text(vars__), n.access().load().bigIntegerValue(), k.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%1s%5s%5s%5s%5s%5s%6s", vars__.Rc.access().load().toString(), k.access().load().add(n.access().load()).subtract(Data.valueOf(SHIFT, 0x1)).toString(), k.access().load().toString(), Data.valueOf(SHIFT, 0x0).subtract(k.access().load()).subtract(n.access().load()).toString(), ra.image(vars__), rs.image(vars__), vars__.OPCD.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new rlwimi(ra, rs, new Immediate(Data.valueOf(SHIFT, 0x0).subtract(k.access().load()).subtract(n.access().load())), k, new Immediate(k.access().load().add(n.access().load()).subtract(Data.valueOf(SHIFT, 0x1)))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}