/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class rlwimi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "rlwimi",
          rlwimi.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);
      addArgument("MB", SHIFT);
      addArgument("ME", SHIFT);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);
      final Immediate MB = (Immediate) getArgument("MB", args);
      final Immediate ME = (Immediate) getArgument("ME", args);

      return new rlwimi(ra, rs, SH, MB, ME);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "rlwimi",
          instruction.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("SH", SHIFT);
      addArgument("MB", SHIFT);
      addArgument("ME", SHIFT);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate SH = (Immediate) getArgument("SH", args);
      final Immediate MB = (Immediate) getArgument("MB", args);
      final Immediate ME = (Immediate) getArgument("ME", args);

      return new instruction(
        new rlwimi(
          ra,
          rs,
          SH,
          MB,
          ME
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R ra;
  public final R rs;
  public final Immediate SH;
  public final Immediate MB;
  public final Immediate ME;

  public rlwimi(final R ra, final R rs, final Immediate SH, final Immediate MB, final Immediate ME) {
    this.ra = ra;
    this.rs = rs;
    this.SH = SH;
    this.MB = MB;
    this.ME = ME;

    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("SH", SH);
    addArgument("MB", MB);
    addArgument("ME", ME);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.Rc.access().store(Data.valueOf(BIT, 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("rlwimi %s", new rlwimi_general(new Immediate(vars__.Rc.access()), ra, rs, SH, MB, ME).text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s", new rlwimi_general(new Immediate(vars__.Rc.access()), ra, rs, SH, MB, ME).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new rlwimi_general(new Immediate(vars__.Rc.access()), ra, rs, SH, MB, ME).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}