/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class rotlw extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "rotlw",
          rotlw.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("rb", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final R rb = (R) getArgument("rb", args);

      return new rotlw(ra, rs, rb);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "rotlw",
          instruction.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("rb", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final R rb = (R) getArgument("rb", args);

      return new instruction(
        new rotlw(
          ra,
          rs,
          rb
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R ra;
  public final R rs;
  public final R rb;

  public rotlw(final R ra, final R rs, final R rb) {
    this.ra = ra;
    this.rs = rs;
    this.rb = rb;

    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("rb", rb);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("rotlw %s, %s, %s", ra.text(vars__), rs.text(vars__), rb.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%s", new rlwnm(ra, rs, rb, new Immediate(Data.valueOf(SHIFT, 0x0)), new Immediate(Data.valueOf(SHIFT, 0x1f))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new rlwnm(ra, rs, rb, new Immediate(Data.valueOf(SHIFT, 0x0)), new Immediate(Data.valueOf(SHIFT, 0x1f))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}