/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.powerpc.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.powerpc.PE;
import ru.ispras.microtesk.model.powerpc.TempVars;
import ru.ispras.microtesk.model.powerpc.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.powerpc.TypeDefs.*;

public final class xoris extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "xoris",
          xoris.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("uimm", HWORD);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate uimm = (Immediate) getArgument("uimm", args);

      return new xoris(ra, rs, uimm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "xoris",
          instruction.class,
          null
          );
      addArgument("ra", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("uimm", HWORD);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R ra = (R) getArgument("ra", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate uimm = (Immediate) getArgument("uimm", args);

      return new instruction(
        new xoris(
          ra,
          rs,
          uimm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R ra;
  public final R rs;
  public final Immediate uimm;

  public xoris(final R ra, final R rs, final Immediate uimm) {
    this.ra = ra;
    this.rs = rs;
    this.uimm = uimm;

    addArgument("ra", ra);
    addArgument("rs", rs);
    addArgument("uimm", uimm);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.OPCD.access().store(Data.valueOf(Type.CARD(6), 0x1b));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("xoris %s, %s, %d", ra.text(vars__), rs.text(vars__), uimm.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%6s%5s%5s%16s", vars__.OPCD.access().load().toString(), rs.image(vars__), ra.image(vars__), uimm.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    ra.access(pe__, vars__).store(rs.access(pe__, vars__).load().xor(Data.zeroExtend(WORD, uimm.access().load()).shiftLeft(Data.valueOf(WORD, 0x10))));
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}