/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem;

import java.math.BigInteger;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Label;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends ProcessingElement {
  public final Memory GPR;
  public final Memory MEM;
  public final Memory PC;

  private PE() {
    super();
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.HWORD, 16);
    this.MEM = Memory.def(Memory.Kind.MEM, "MEM", TypeDefs.HWORD, 0x2000);
    this.PC = Memory.def(Memory.Kind.REG, "PC", TypeDefs.HWORD, 1);

    registerAll();
  }

  private PE(final PE other, final boolean shared) {
    super(other);
    this.GPR = other.GPR.copy();
    this.MEM = other.MEM.copy();
    this.PC = other.PC.copy();

    registerAll();
  }

  private void registerAll() {
    addStorage(GPR);
    addStorage(MEM);
    addStorage(PC);
  }

  @Override
  public ProcessingElement copy(final boolean shared) {
    return new PE(this, shared);
  }

  private static final class PEFactory implements Factory {
    @Override
    public PE create() {
      return new PE();
    }
  }

  public static Factory newFactory() {
    return new PEFactory();
  }
}
